// AboutDlg.cpp : implementation file
//

#include "stdafx.h"
#include "AutoSave.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


#define ACTIVE_COLOR_ON  RGB(0, 0, 128);
#define ACTIVE_COLOR_OFF RGB(0, 0, 255);


/////////////////////////////////////////////////////////////////////////////
// AboutDlg dialog


AboutDlg::AboutDlg(CWnd* pParent /*=NULL*/)
	: CDialog(AboutDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(AboutDlg)
	m_version = _T("");
	//}}AFX_DATA_INIT
}


void AboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(AboutDlg)
	DDX_Control(pDX, IDC_URL, m_urlText);
	DDX_Control(pDX, IDC_EMAIL, m_emailText);
	DDX_Text(pDX, IDC_VERSION, m_version);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(AboutDlg, CDialog)
	//{{AFX_MSG_MAP(AboutDlg)
	ON_WM_CTLCOLOR()
	ON_WM_LBUTTONDOWN()
	ON_WM_MOUSEMOVE()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// AboutDlg message handlers

BOOL AboutDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();

	m_version = AUTOSAVE_VERSION_STRING;
	UpdateData(FALSE);

	// Load the cursors needed for the dialog
	m_helpCursor = ::LoadCursor(NULL, IDC_HELP);
	m_defaultCursor = ::LoadCursor(NULL, IDC_ARROW);
	m_previousMousePos = moUnknown;

	// Get the coordinates of the URL control and assign a default color
	m_urlText.GetWindowRect(m_rcUrl);
	ScreenToClient(m_rcUrl);
	m_urlColor = ACTIVE_COLOR_OFF;

	// Get the coordinates of the e-mail control and assign a default color
	m_emailText.GetWindowRect(m_rcEmail);
	ScreenToClient(m_rcEmail);
	m_emailColor = ACTIVE_COLOR_OFF;

	return TRUE;
}

HBRUSH AboutDlg::OnCtlColor(CDC* pDC, CWnd* pWnd, UINT nCtlColor) 
{
	// Assign the required color to the active controls

	HBRUSH hbr = CDialog::OnCtlColor(pDC, pWnd, nCtlColor);

	int id = pWnd->GetDlgCtrlID();

	if (id == IDC_EMAIL)
	{
		// Set the text color to blue
		pDC->SetTextColor(m_emailColor);
		pDC->SetBkMode(TRANSPARENT);
	}
	else if (id == IDC_URL)
	{
		// Set the text color to blue
		pDC->SetTextColor(m_urlColor);
		pDC->SetBkMode(TRANSPARENT);
	}

	return hbr;
}

void AboutDlg::OnLButtonDown(UINT nFlags, CPoint point) 
{
	// This override executes the command of the active controls. It
	// enables to either send me e-mail to go to my homepage

	if (m_rcUrl.PtInRect(point))
		::ShellExecute(NULL, "open", "http://come.to/itay", NULL, NULL, SW_SHOWNORMAL);
	else if (m_rcEmail.PtInRect(point))
		::ShellExecute(NULL, "open", "mailto:etay@writeme.com", NULL, NULL, SW_SHOWNORMAL);
	CDialog::OnLButtonDown(nFlags, point);
}

void AboutDlg::OnMouseMove(UINT nFlags, CPoint point) 
{
	// The purpose of this override is to change the color and the mouse
	// cursor when moving over an active control (either the URL or e-mail
	// static text controls)

	// If we're over the URL control
	if (m_rcUrl.PtInRect(point))
	{
		if (m_previousMousePos != moUrl)
		{
			m_previousMousePos = moUrl;
			m_urlColor = ACTIVE_COLOR_ON;
			m_urlText.Invalidate();
			m_emailColor = ACTIVE_COLOR_OFF;
			m_emailText.Invalidate();
		}
		::SetCursor(m_helpCursor);
	}
	// If we're over the e-mail control
	else if (m_rcEmail.PtInRect(point))
	{
		if (m_previousMousePos != moEmail)
		{
			m_previousMousePos = moEmail;
			m_emailColor = ACTIVE_COLOR_ON;
			m_emailText.Invalidate();
			m_urlColor = ACTIVE_COLOR_OFF;
			m_urlText.Invalidate();
		}
		::SetCursor(m_helpCursor);
	}
	// Otherwise
	else
	{
		if (m_previousMousePos == moUrl || m_previousMousePos == moUnknown)
		{
			m_urlColor = ACTIVE_COLOR_OFF;
			m_urlText.Invalidate();
		}

		if (m_previousMousePos == moEmail || m_previousMousePos == moUnknown)
		{
			m_emailColor = ACTIVE_COLOR_OFF;
			m_emailText.Invalidate();
		}

		::SetCursor(m_defaultCursor);
		m_previousMousePos = moDialog;
	}
	
	CDialog::OnMouseMove(nFlags, point);
}
