// AutoSaveDlg.cpp : implementation file
//

#include "stdafx.h"
#include "AutoSave.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

extern TimerWindow *gTimer;

/////////////////////////////////////////////////////////////////////////////
// AutoSaveDlg dialog


AutoSaveDlg::AutoSaveDlg(CWnd* pParent /*=NULL*/)
	: CDialog(AutoSaveDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(AutoSaveDlg)
	m_saveFiles = TRUE;
	m_saveWorkspace = TRUE;
	m_protectIntellisense = TRUE;
	m_period = 0;
	//}}AFX_DATA_INIT
}


void AutoSaveDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(AutoSaveDlg)
	DDX_Control(pDX, IDC_ABOUT, m_aboutButton);
	DDX_Check(pDX, IDC_SAVE_FILES, m_saveFiles);
	DDX_Check(pDX, IDC_SAVE_WORKSPACE, m_saveWorkspace);
	DDX_Check(pDX, IDC_PROTECT_INTELLISENSE, m_protectIntellisense);
	DDX_Text(pDX, IDC_PERIOD, m_period);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(AutoSaveDlg, CDialog)
	//{{AFX_MSG_MAP(AutoSaveDlg)
	ON_WM_CREATE()
	ON_BN_CLICKED(IDC_ABOUT, OnAbout)
	ON_WM_DESTROY()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// AutoSaveDlg message handlers

int AutoSaveDlg::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
	if (CDialog::OnCreate(lpCreateStruct) == -1)
		return -1;

	// Initialize the dialog box data
	m_period = gTimer->getPeriod();
	m_saveFiles = gTimer->getSaveFiles() ? 1 : 0;
	m_saveWorkspace = gTimer->getSaveWorkspace() ? 1 : 0;
	m_protectIntellisense = gTimer->getProtectIntellisense() ? 1 : 0;
	
	return 0;
}

BOOL AutoSaveDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();

	m_aboutBitmap.LoadBitmap(IDB_QUESTION);
	m_aboutButton.SetBitmap(m_aboutBitmap);

	return TRUE;
}

void AutoSaveDlg::OnOK() 
{
	// Update the timer settings based on the entered data
	UpdateData(TRUE);
	gTimer->setPeriod(m_period);
	gTimer->setSaveFiles(m_saveFiles != 0);
	gTimer->setSaveWorkspace(m_saveWorkspace != 0);
	gTimer->setProtectIntellisense(m_protectIntellisense != 0);
	
	CDialog::OnOK();
}

void AutoSaveDlg::OnAbout() 
{
	AboutDlg about;
	about.DoModal();
}
